#include<bits/stdc++.h>

using namespace std;

int n,m,k,boje = 0;
int mat[1010][1010];

void susedi(int y,int x)
{
    if(x!=1){
        if(!mat[y][x-1]){
            mat[y][x-1] = 1;
            susedi(y,x-1);
        }
    }
    if(x!=m){
        if(!mat[y][x+1]){
            mat[y][x+1] = 1;
            susedi(y,x+1);
        }
    }
    if(y!=1){
        if(!mat[y-1][x]){
            mat[y-1][x] = 1;
            susedi(y-1,x);
        }
    }
    if(y!=n){
        if(!mat[y+1][x]){
            mat[y+1][x] = 1;
            susedi(y+1,x);
        }
    }
}

void resenje()
{
    for(int y = 1;y<=n;y++){
        for(int x = 1;x<=m;x++){
            if(mat[y][x] == 0){
                mat[y][x] = 1;
                boje++;
                susedi(y,x);
            }
        }
    }
}

int main()
{
    cin>>n>>m>>k;
    int l,c;
    for(int i = 0;i<k;i++){
        cin>>l>>c;
        mat[l][c] = 1;
    }
    resenje();
    cout<<boje;
    return 0;
}